//=============================================================================
//
// file :        Timer.h
//
// description : Include for the Timer class.
//
// project :	timer
//
// $Author: zambonl $
//
// $Revision: 1.1.1.1 $
//
// $Log: Timer.h,v $
// Revision 1.1.1.1  2013-09-06 09:40:41  zambonl
// Prima versione di timer
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza (TS)
//              ITALY
//
//-=============================================================================
//
//              This file is generated by POGO
//      (Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF 
//=============================================================================
#ifndef _TIMER_H
#define _TIMER_H

#include <tango.h>
//using namespace Tango;

/**
 * @author	$Author: zambonl $
 * @version	$Revision: 1.1.1.1 $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------


namespace Timer_ns
{

/**
 * Class Description:
 * this is a timer, designed to sleep for a while, is is usefull for a sequencer
 */

/*
 *	Device States Description:
 */


class Timer: public TANGO_BASE_CLASS
{
public :
	//	Add your own data members here
	//-----------------------------------------
	void msleep(long milliseconds);		
	char timeLong[80];
	void timestamp();


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevLong	*attr_TimeToGo_read;
		Tango::DevBoolean	*attr_StateFlags_read;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	Timer(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	Timer(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	Timer(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~Timer() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name Timer methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for TimeToGo acquisition result.
 */
	virtual void read_TimeToGo(Tango::Attribute &attr);
/**
 *	Extract real attribute values for StateFlags acquisition result.
 */
	virtual void read_StateFlags(Tango::Attribute &attr);
/**
 *	Read/Write allowed for TimeToGo attribute.
 */
	virtual bool is_TimeToGo_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for StateFlags attribute.
 */
	virtual bool is_StateFlags_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for Stop command.
 */
	virtual bool is_Stop_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Start command.
 */
	virtual bool is_Start_allowed(const CORBA::Any &any);
/**
 * stop and reset timer
 *	@exception DevFailed
 */
	void	stop();
/**
 * 
 *	@param	argin	time to sleep for
 *	@exception DevFailed
 */
	void	start(Tango::DevDouble);

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	Tango::DevBoolean *attr_ab_rd;
	Tango::DevVarBooleanArray datab;
	Tango::DevLong attr_l_rd;
	long startTime, requiredTime;
};

}	// namespace_ns

#endif	// _TIMER_H
