//=============================================================================
//
// file :         TimerClass.h
//
// description :  Include for the TimerClass root class.
//                This class is represents the singleton class for
//                the Timer device class.
//                It contains all properties and methods which the 
//                Timer requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: zambonl $
//
// $Revision: 1.1.1.1 $
//
// $Log: TimerClass.h,v $
// Revision 1.1.1.1  2013-09-06 09:40:41  zambonl
// Prima versione di timer
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza (TS)
//              ITALY
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF 
//=============================================================================

#ifndef _TIMERCLASS_H
#define _TIMERCLASS_H

#include <tango.h>
#include <Timer.h>


namespace Timer_ns
{
//=====================================
//	Define classes for attributes
//=====================================
class StateFlagsAttrib: public Tango::SpectrumAttr
{
public:
	StateFlagsAttrib():SpectrumAttr("StateFlags", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~StateFlagsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Timer *>(dev))->read_StateFlags(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Timer *>(dev))->is_StateFlags_allowed(ty);}
};

class TimeToGoAttrib: public Tango::Attr
{
public:
	TimeToGoAttrib():Attr("TimeToGo", Tango::DEV_LONG, Tango::READ) {};
	~TimeToGoAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Timer *>(dev))->read_TimeToGo(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Timer *>(dev))->is_TimeToGo_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class StartClass : public Tango::Command
{
public:
	StartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Timer *>(dev))->is_Start_allowed(any);}
};



class StopCmd : public Tango::Command
{
public:
	StopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Timer *>(dev))->is_Stop_allowed(any);}
};



//
// The TimerClass singleton definition
//

class TimerClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static TimerClass *init(const char *);
	static TimerClass *instance();
	~TimerClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	TimerClass(string &);
	static TimerClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace Timer_ns

#endif // _TIMERCLASS_H
